/*
 * JEFFREE: Java(TM) Embedded Framework FREE
 * Copyright (C) 1999-2003 - Opensugar
 *
 * The contents of this file are subject to the Jeffree Public License,
 * as defined by the file JEFFREE_LICENSE.TXT 
 * 
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the Objectweb web site
 * (www.objectweb.org). 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License. 
 * 
 * The Original Code is JEFFREE, including the java package com.opensugar.cube,
 * released January 1, 2003.
 * 
 * The Initial Developer of the Original Code is Opensugar.
 * The Original Code is Copyright Opensugar.
 * All Rights Reserved.
 *
 * Initial developer(s): Pierre Scokaert (Opensugar)
 * Contributor(s):
 */

package com.opensugar.cube;

import org.osgi.framework.BundleListener;
import org.osgi.framework.SynchronousBundleListener;

import java.util.Enumeration;
import java.util.Vector;

public class BundleListeners extends ListenerSet {

   public SynchronousBundleListener[] getSynchronousBundleListeners() {
      Enumeration enum = getAllListeners();
      Vector listeners = new Vector();
      while ( enum.hasMoreElements() ) {
         Object listener = enum.nextElement();
         if ( listener instanceof SynchronousBundleListener ) {
            listeners.addElement( listener );
         }
      }
      SynchronousBundleListener[] ret = new SynchronousBundleListener[ listeners.size() ];
      listeners.copyInto( ret );
      return ret;
   }

   public BundleListener[] getNonSynchronousBundleListeners() {
      Enumeration enum = getAllListeners();
      Vector listeners = new Vector();
      while ( enum.hasMoreElements() ) {
         Object listener = enum.nextElement();
         if ( !( listener instanceof SynchronousBundleListener ) ) {
            listeners.addElement( listener );
         }
      }
      BundleListener[] ret = new BundleListener[ listeners.size() ];
      listeners.copyInto( ret );
      return ret;
   }

}