/*
 * JEFFREE: Java(TM) Embedded Framework FREE
 * Copyright (C) 1999-2003 - Opensugar
 *
 * The contents of this file are subject to the Jeffree Public License,
 * as defined by the file JEFFREE_LICENSE.TXT
 *
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the Objectweb web site
 * (www.objectweb.org).
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 * The Original Code is JEFFREE, including the java package com.opensugar.cube,
 * released January 1, 2003.
 *
 * The Initial Developer of the Original Code is Opensugar.
 * The Original Code is Copyright Opensugar.
 * All Rights Reserved.
 *
 * Initial developer(s): Pierre Scokaert (Opensugar)
 * Contributor(s):
 */

package com.opensugar.cube;

import com.opensugar.cube.simple.CubeWithoutPermissions;

import java.io.File;
import java.util.Observer;

public class Launcher {

   public static void main( String[] args ) {
      main( args, null );
   }

   public static void main( String[] args, Object splashScreen ) {
      new Launcher( null, splashScreen );
   }

   public Launcher( File baseDirectory, Object splashScreen ) {
      AbstractCube cube = newCube( baseDirectory );

      Observer progressListener = null;
      if ( splashScreen instanceof Observer ) {
         progressListener = (Observer)splashScreen;
      }

      cube.startup( progressListener );

      if ( splashScreen != null ) {
         try {
            Thread.sleep( 500 );
         }
         catch ( InterruptedException ignore ) {}
         ( (java.awt.Window)splashScreen ).dispose();
         splashScreen = null;
      }

      Object obj = new Object();
      synchronized( obj ) {
         try {
            obj.wait();
         }
         catch ( InterruptedException ignore ) {}
      }
   }

   // if org.osgi.framework.permissions is null --> do permissions if jvm supports them
   // if org.osgi.framework.permissions is true --> do permissions, and exit if jvm does not support them
   // otherwise, don't do permissions
   protected AbstractCube newCube( File baseDirectory ) {
      return newCubeWithoutPermissions( baseDirectory );
   }

   private AbstractCube newCubeWithoutPermissions( File baseDirectory ) {
      return new CubeWithoutPermissions( baseDirectory );
   }

}
