/*
 * JEFFREE: Java(TM) Embedded Framework FREE
 * Copyright (C) 1999-2003 - Opensugar
 *
 * The contents of this file are subject to the Jeffree Public License,
 * as defined by the file JEFFREE_LICENSE.TXT 
 * 
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the Objectweb web site
 * (www.objectweb.org). 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License. 
 * 
 * The Original Code is JEFFREE, including the java package com.opensugar.cube,
 * released January 1, 2003.
 * 
 * The Initial Developer of the Original Code is Opensugar.
 * The Original Code is Copyright Opensugar.
 * All Rights Reserved.
 *
 * Initial developer(s): Pierre Scokaert (Opensugar)
 * Contributor(s):
 */

package com.opensugar.cube.simple;

import com.opensugar.cube.AbstractCube;
import com.opensugar.cube.BundleImpl;
import com.opensugar.cube.BundleClassLoader;
import com.opensugar.cube.NamedPropertySet;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleException;

import java.io.File;
import java.io.IOException;

// Cube without permission checks.
// Should work on any virtual machines that support Java 1.1 or above.
public class CubeWithoutPermissions extends AbstractCube {

   public CubeWithoutPermissions() {
      this( null );
   }

   public CubeWithoutPermissions( File baseDirectory ) {
      super( baseDirectory );
      log( LOG_INFO, "Permissions not supported" );
   }

   protected boolean enforcesPermissions() {
      return false;
   }

   public void checkAdminPermission() {
   }

   public void checkFilePermission( String file, String permissionToCheck ) {
   }

   public void checkPackagePermission( NamedPropertySet[] packages, String permissionToCheck, Object codeSource ) {
   }

   public void checkPropertyPermission( String property, String permissionToCheck ) {
   }

   public void checkServicePermission( String className, String permissionToCheck ) {
   }

   public void checkServicePermissionForAll( String[] classNames, String permissionToCheck ) {
   }

   public void checkServicePermissionForAtLeastOne( String[] classNames, String permissionToCheck ) {
   }

   protected boolean hasPermission( BundleImpl bundle, Object permission ) {
      return true;
   }

   protected BundleClassLoader createClassLoaderForBundle( BundleImpl bundle, File bundleJarFile, NamedPropertySet[] nativeLibraries, NamedPropertySet[] classPath ) throws IOException {
      return SimpleBundleClassLoader.createClassLoader( bundle, bundleJarFile, nativeLibraries, classPath );
   }

}